function [MDLSCORE, tpathnew] = MDL(Graph, Infection, Seeds, beta)
% R is composed of ripples R_0, R_1.....
% S is a set of buckets. S_i = seeds only at time i
% C = buckets of corrections. C_i = nodes infected but not in D
% I_i nodes we think were infected at time stamp i.

global MDL_MAX;
tpath = [];
tpathnew = [];
singletons = [];
infected = find(Infection);
nnodes = length(Graph(1,:));
[M N] = graphconncomp(sparse(Graph(infected, infected)));
S = zeros(M, nnodes);
I = zeros(M, nnodes);
% S should be a part of infected current

if isempty(find(Seeds))
    Seeds;
end
for s = find(Seeds)
    if isempty(find(infected == s))
        s;
    end
    assert(~isempty(find(infected == s)));
end
% Divide the infectedCurrent graph into M mdl computations
for i = 1:M
    subInfCurr = infected(find(N == i));
    for node = subInfCurr
        if find(infected == node)
            I(i, node) = 1; 
        end
        if Seeds(1, node) == 1
            S(i, node) = 1;
        end
    end
end
extra = 0;
notTocheck = [];
% Check for seed in every connected component
for i = 1:M
    %assert(sum(S(i,:)) > 0)
    if sum(S(i,:)) == 0
        if sum(I(i,:)) ~= 1
            display('Error no seed in connected component')
            MDLSCORE = MDL_MAX;
            return;
        end
    end
end
MDLSCORE = 0;
MDL_r = 0;
MDL_c = 0;
if M > 1
    for i = 1:M
%         if length(find(N == i)) < 4
%             continue;
%         end
        if ~isempty(find(notTocheck == i))
            continue;
        end
        V = ones(1, length(Graph(1,:)));
        mdl_s = MDL_S(I(i,:), S(i,:), V);
        [mdl_r, tpath] = MDL_R(Graph, I(i,:), S(i,:),beta);
        tpathnew = [tpathnew tpath];
        MDL_r = MDL_r + mdl_r;
        mdl = mdl_s + mdl_r;
        MDLSCORE = MDLSCORE + mdl;
    end
else
    V = ones(1, length(Graph(1,:)));
    mdl_s = MDL_S(I, S, V);
    [mdl_r, tpath] = MDL_R(Graph, I, S,beta);
    tpathnew = [tpathnew tpath];
    mdl = mdl_s + mdl_r;
    MDL_r = MDL_r + mdl_r;
    MDLSCORE = mdl;
end

MDLSCORE_r = MDL_r;
MDL_r;
MDL_c;
end

